summaryrefslogtreecommitdiff
path: root/plugins/jsontools
diff options
context:
space:
mode:
authorTuowen Zhao <ztuowen@gmail.com>2021-09-27 13:03:58 -0600
committerTuowen Zhao <ztuowen@gmail.com>2021-09-27 13:03:58 -0600
commitc674485e6b4abe313469900997d893d2940ee843 (patch)
treed6ca6edaff3d81849489f31ca13b127acef89c75 /plugins/jsontools
parent3c73976ef306d68a85d60c94be9a1dcdc33fa2bf (diff)
parent93ad3a88214b95f571e03c21f7d9bd76f9110938 (diff)
downloadzsh-c674485e6b4abe313469900997d893d2940ee843.tar.gz
zsh-c674485e6b4abe313469900997d893d2940ee843.tar.bz2
zsh-c674485e6b4abe313469900997d893d2940ee843.zip
Merge remote-tracking branch 'origin/master'
Diffstat (limited to 'plugins/jsontools')
-rw-r--r--plugins/jsontools/README.md47
-rw-r--r--plugins/jsontools/jsontools.plugin.zsh137
2 files changed, 143 insertions, 41 deletions
diff --git a/plugins/jsontools/README.md b/plugins/jsontools/README.md
index 1fa2b8eed..6a2740014 100644
--- a/plugins/jsontools/README.md
+++ b/plugins/jsontools/README.md
@@ -17,32 +17,63 @@ Usage is simple... just take your json data and pipe it into the appropriate jso
- `urlencode_json`: returns a url encoded string for the given json.
- `urldecode_json`: returns decoded json for the given url encoded string.
+### Supports NDJSON (Newline Delimited JSON)
+
+The plugin also supports [NDJSON](http://ndjson.org/) input, which means all functions
+have an alternative function that reads and processes the input line by line. These
+functions have the same name except using `ndjson` instead of `json`:
+
+> `pp_ndjson`, `is_ndjson`, `urlencode_ndjson`, `urldecode_ndjson`.
+
### Examples
- **pp_json**:
-```sh
+```console
# curl json data and pretty print the results
curl https://coderwall.com/bobwilliams.json | pp_json
```
- **is_json**:
-```sh
-# Validate if file's content conforms to a valid JSON schema
-less data.json | is_json
+```console
+# validate if file's content conforms to a valid JSON schema
+$ is_json < data.json
+true
+# shows true / false and returns the proper exit code
+$ echo $?
+0
```
- **urlencode_json**:
-```sh
+```console
# json data directly from the command line
-echo '{"b":2, "a":1}' | urlencode_json
+$ echo '{"b":2, "a":1}' | urlencode_json
+%7B%22b%22:2,%20%22a%22:1%7D
```
- **urldecode_json**:
-```sh
+```console
# url encoded string to decode
-echo '%7B%22b%22:2,%20%22a%22:1%7D%0A' | urldecode_json
+$ echo '%7B%22b%22:2,%20%22a%22:1%7D' | urldecode_json
+{"b":2, "a":1}
+```
+
+- **pp_ndjson**:
+
+```console
+# echo two separate json objects and pretty print both
+$ echo '{"a": "b"}\n{"c": [1,2,3]}' | pp_ndjson
+{
+ "a": "b"
+}
+{
+ "c": [
+ 1,
+ 2,
+ 3
+ ]
+}
```
diff --git a/plugins/jsontools/jsontools.plugin.zsh b/plugins/jsontools/jsontools.plugin.zsh
index 912c83509..ed45cfa8e 100644
--- a/plugins/jsontools/jsontools.plugin.zsh
+++ b/plugins/jsontools/jsontools.plugin.zsh
@@ -1,42 +1,113 @@
# JSON Tools
# Adds command line aliases useful for dealing with JSON
-if [[ $(whence $JSONTOOLS_METHOD) = "" ]]; then
- JSONTOOLS_METHOD=""
+# Check that user-defined method is installed
+if [[ -n "$JSONTOOLS_METHOD" ]]; then
+ (( $+commands[$JSONTOOLS_METHOD] )) || unset JSONTOOLS_METHOD
fi
-if [[ $(whence node) != "" && ( "x$JSONTOOLS_METHOD" = "x" || "x$JSONTOOLS_METHOD" = "xnode" ) ]]; then
- alias pp_json='xargs -0 node -e "console.log(JSON.stringify(JSON.parse(process.argv[1]), null, 4));"'
- alias is_json='xargs -0 node -e "try {json = JSON.parse(process.argv[1]);} catch (e) { console.log(false); json = null; } if(json) { console.log(true); }"'
- alias urlencode_json='xargs -0 node -e "console.log(encodeURIComponent(process.argv[1]))"'
- alias urldecode_json='xargs -0 node -e "console.log(decodeURIComponent(process.argv[1]))"'
-elif [[ $(whence python) != "" && ( "x$JSONTOOLS_METHOD" = "x" || "x$JSONTOOLS_METHOD" = "xpython" ) ]]; then
- alias pp_json='python -c "import sys; del sys.path[0]; import runpy; runpy._run_module_as_main(\"json.tool\")"'
- alias is_json='python -c "
+# If method undefined, find the first one that is installed
+if [[ ! -v JSONTOOLS_METHOD ]]; then
+ for JSONTOOLS_METHOD in node python ruby; do
+ # If method found, break out of loop
+ (( $+commands[$JSONTOOLS_METHOD] )) && break
+ # Otherwise unset the variable
+ unset JSONTOOLS_METHOD
+ done
+
+ # If no methods were found, exit the plugin
+ [[ -v JSONTOOLS_METHOD ]] || return 1
+fi
+
+# Define json tools for each method
+case "$JSONTOOLS_METHOD" in
+ node)
+ # node doesn't make it easy to deal with stdin, so we pass it as an argument with xargs -0
+ function pp_json() {
+ xargs -0 node -e 'console.log(JSON.stringify(JSON.parse(process.argv[1]), null, 4));'
+ }
+ function is_json() {
+ xargs -0 node -e '
+ try {
+ json = JSON.parse(process.argv[1]);
+ console.log("true");
+ process.exit(0);
+ } catch (e) {
+ console.log("false");
+ process.exit(1);
+ }
+ '
+ }
+ function urlencode_json() {
+ xargs -0 node -e "console.log(encodeURIComponent(process.argv[1]))"
+ }
+ function urldecode_json() {
+ xargs -0 node -e "console.log(decodeURIComponent(process.argv[1]))"
+ }
+ ;;
+ python)
+ function pp_json() {
+ python -c 'import sys; del sys.path[0]; import runpy; runpy._run_module_as_main("json.tool")'
+ }
+ function is_json() {
+ python -c '
import sys; del sys.path[0];
-import json;
-try:
- json.loads(sys.stdin.read())
-except ValueError, e:
- print False
-else:
- print True
-sys.exit(0)"'
- alias urlencode_json='python -c "
+import json
+try:
+ json.loads(sys.stdin.read())
+ print("true"); sys.exit(0)
+except ValueError:
+ print("false"); sys.exit(1)
+ '
+ }
+ function urlencode_json() {
+ python -c '
import sys; del sys.path[0];
-import urllib, json;
-print urllib.quote_plus(sys.stdin.read())
-sys.exit(0)"'
- alias urldecode_json='python -c "
+from urllib.parse import quote_plus
+print(quote_plus(sys.stdin.read()))
+ '
+ }
+ function urldecode_json() {
+ python -c '
import sys; del sys.path[0];
-import urllib, json;
-print urllib.unquote_plus(sys.stdin.read())
-sys.exit(0)"'
-elif [[ $(whence ruby) != "" && ( "x$JSONTOOLS_METHOD" = "x" || "x$JSONTOOLS_METHOD" = "xruby" ) ]]; then
- alias pp_json='ruby -e "require \"json\"; require \"yaml\"; puts JSON.parse(STDIN.read).to_yaml"'
- alias is_json='ruby -e "require \"json\"; begin; JSON.parse(STDIN.read); puts true; rescue Exception => e; puts false; end"'
- alias urlencode_json='ruby -e "require \"uri\"; puts URI.escape(STDIN.read)"'
- alias urldecode_json='ruby -e "require \"uri\"; puts URI.unescape(STDIN.read)"'
-fi
-
+from urllib.parse import unquote_plus
+print(unquote_plus(sys.stdin.read()))
+ '
+ }
+ ;;
+ ruby)
+ function pp_json() {
+ ruby -e '
+ require "json"
+ require "yaml"
+ puts JSON.parse(STDIN.read).to_yaml
+ '
+ }
+ function is_json() {
+ ruby -e '
+ require "json"
+ begin
+ puts !!JSON.parse(STDIN.read); exit(0)
+ rescue JSON::ParserError
+ puts false; exit(1)
+ end
+ '
+ }
+ function urlencode_json() {
+ ruby -e 'require "cgi"; puts CGI.escape(STDIN.read)'
+ }
+ function urldecode_json() {
+ ruby -e 'require "cgi"; puts CGI.unescape(STDIN.read)'
+ }
+ ;;
+esac
unset JSONTOOLS_METHOD
+
+## Add NDJSON support
+
+function {pp,is,urlencode,urldecode}_ndjson() {
+ local json jsonfunc="${0//ndjson/json}"
+ while read -r json; do
+ $jsonfunc <<< "$json"
+ done
+}